<?php
/**
* Copyright 2016 aheadWorks. All rights reserved.
* See LICENSE.txt for license details.
*/

namespace Aheadworks\OneStepCheckout\Model\Layout\Processor\Totals;

/**
 * Class Merger
 * @package Aheadworks\OneStepCheckout\Model\Layout\Processor\Totals
 */
class Merger
{
    /**
     * @var array
     */
    private $componentsToExclude = ['aw-reward-points', 'aw-store-credit'];

    /**
     * @var array
     */
    private $componentsToReplace = [];

    /**
     * @var array
     */
    private $componentToMergeFromConfig = ['discount', 'shipping'];

    /**
     * Merge totals config definitions
     *
     * @param array $config
     * @param array $sourceConfig
     * @return array
     */
    public function merge(array $config, array $sourceConfig)
    {
        foreach ($sourceConfig as $code => $configData) {
            if (!in_array($code, $this->componentsToExclude)) {
                $configUpdate = [];

                if (in_array($code, $this->componentsToReplace)) {
                    $configUpdate = $configData;
                } else {
                    $uiComponent = isset($configData['component'])
                        ? $configData['component']
                        : 'uiComponent';
                    $configUpdate['component'] = $uiComponent;
                    if (isset($configData['config'])) {
                        if (!isset($config[$code]['config'])) {
                            $configUpdate['config'] = $configData['config'];
                        } else {
                            $configUpdate['config'] = array_merge($config[$code]['config'], $configData['config']);
                        }
                    }
                }
                if (in_array($code, $this->componentToMergeFromConfig)) {
                    $configUpdate = array_merge($configUpdate, $config[$code]);
                }

                $config[$code] = $configUpdate;
            }
        }
        return $config;
    }
}
