/**
* Copyright 2016 aheadWorks. All rights reserved.
* See LICENSE.txt for license details.
*/

define(
    [
        'Magento_Checkout/js/model/url-builder',
        'mage/storage',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/model/quote'
    ],
    function (
        urlBuilder,
        storage,
        customer,
        quote
    ) {
        'use strict';

        return function (log) {
            var serviceUrl,
                payload = {fieldCompleteness: log};

            if (!customer.isLoggedIn()) {
                serviceUrl = urlBuilder.createUrl('/awOsc/guest-carts/:cartId/completeness-log', {
                    cartId: quote.getQuoteId()
                });
            } else {
                serviceUrl = urlBuilder.createUrl('/awOsc/carts/mine/completeness-log', {});
            }

            return storage.post(serviceUrl, JSON.stringify(payload));
        }
    }
);
