/**
* Copyright 2016 aheadWorks. All rights reserved.
* See LICENSE.txt for license details.
*/

define(
    [
        'jquery',
        'Magento_Checkout/js/view/summary/abstract-total',
        'Magento_Checkout/js/model/quote'
    ],
    function ($, Component, quote) {
        return Component.extend({
            defaults: {
                template: 'Aheadworks_OneStepCheckout/totals/shipping'
            },
            quoteIsVirtual: quote.isQuoteVirtual,
            totals: quote.getTotals(),

            /**
             * Get shipping method title
             *
             * @returns {string}
             */
            getShippingMethodTitle: function() {
                var shippingMethod,
                    methodTitle = '';

                if (this.isCalculated()) {
                    shippingMethod = quote.shippingMethod();
                    if (shippingMethod) {
                        methodTitle = shippingMethod.carrier_title + ' - ' + shippingMethod.method_title;
                    }
                }
                return methodTitle;
            },

            /**
             * Check if total value is calculated
             *
             * @returns {boolean}
             */
            isCalculated: function() {
                return this.totals()
                    && this.isFullMode()
                    && null != quote.shippingMethod();
            },

            /**
             * Get formatted total value
             *
             * @returns {string}
             */
            getValue: function() {
                return this.isCalculated()
                    ? this.getFormattedPrice(this.totals().shipping_amount)
                    : this.notCalculatedMessage;
            }
        });
    }
);
